/*
commands
Left mouse button = reverse image 
center mouse button = save a .svg image (will save as test.svg unless key (S) is used first 
right mouse button = change stipple particle
+ and - increase and decrease spacing of stipple particles
L = selects an image to load
S = selects a save file to use (use before using center mouse button)
D = display the image in the background
*/

import processing.svg.*;

float sizes;
float w, x, y, deg; 
float phi = ((sqrt(5) + 1 ) / 2);

int z;
int draw = 0;
int save = 0;
int start = 1;
int spacing = 8;
int stipple = 0;
int display = 0;
int reverse = 0;
int counter = 0;

String saver = "test"; //default save file name .svg added in program
String loaded = "troy.jpg"; //default image (my son)

PImage original_img;
PGraphics fibdraw;
PGraphics maskImage;

void setup() {
  size(605, 605, P2D); 
  frameRate(20);
  restart();
}

void draw(){
    for(z = 34; z > 0; --z){
    deg = (counter * phi) * 360;
    w = sqrt(counter++) * spacing;
    posit(width/2, height/2, w, (deg % 360));
    color pix = original_img.get((int)x, (int)y);
    sizes = map(brightness(pix), 255, 0, 0, 8);//change last 0, 8 for min max size of circles
    strokeWeight(1);
    stroke(0);
    noFill();
     if (stipple == 0) {ellipse(x, y, sizes, sizes); fibdraw.ellipse(x, y, sizes, sizes); }  //circles
    else if (stipple == 1) {rect(x, y, sizes, sizes, 3); fibdraw.rect(x, y, sizes, sizes, 3); }  //lazy squares
    else if (stipple == 2) {rect(x, y, sizes, sizes); fibdraw.rect(x, y, sizes, sizes); }  //squares
    else if (stipple == 3) {triangle(x,y,x-sizes, y, x-(sizes/2),y-sizes); fibdraw.triangle(x,y,x-sizes, y, x-(sizes/2),y-sizes); } //triangles
    else if (stipple == 4) {arc(x, y, sizes, sizes, 0, PI, CHORD); fibdraw.arc(x, y, sizes, sizes, 0, PI, CHORD); }  //half circles up open
    else if (stipple == 5) {arc(x, y, sizes, sizes, PI / 2, 3 * PI / 2, CHORD); fibdraw.arc(x, y, sizes, sizes, PI / 2, 3 * PI / 2, CHORD); }  //half circles right open
    else if (stipple == 6) {arc(x, y, sizes, sizes, -PI, 0, CHORD); fibdraw.arc(x, y, sizes, sizes, -PI, 0, CHORD); }  //half circles down open
    else if (stipple == 7) {arc(x, y, sizes, sizes, 3 * PI / 2, PI * 2.5, CHORD); fibdraw.arc(x, y, sizes, sizes, 3 * PI / 2, PI * 2.5, CHORD); }  //half circles left open
    if (x-spacing <= 0 || y-spacing <= 0 || x+spacing >= height || y+spacing >= width) //up to and touching then stop
      { if (save == 1){saver();}
      noLoop(); }
    }
}

void posit(float sx, float sy, float w, float gradent) {
  x = sx + cos(radians(gradent))*(w/2);
  y = sy + sin(radians(gradent))*(w/2);
}

void mousePressed(){
   if (mouseButton == LEFT){ 
         reverse = 1;
        restart(); 
   }
    else if (mouseButton == CENTER){
      println("supersaver here");
      save = 1;
    }
    else if (mouseButton == RIGHT){
     stipple ++;
     if (stipple > 7) {stipple = 0;}
      restart();
    }
  frameCount = counter = 0;
  loop();
  restart ();
}

void keyPressed() {

  if (key == 'l' || key == 'L') { infile(); }
  else if (key == 's' || key == 'S') { outfile(); }
  else if (key == 'd' || key == 'D') { disp(); }
  else if (key == '+') {spacing = spacing + 1; restart(); }
  else if (key == '-') {spacing = spacing - 1; restart(); }
}

void saver (){
  save = 0;
  fibdraw.endDraw();
  println("super saver finished");
  start = 1;
  restart();
}

void disp(){
  if (display == 1) {
        display = 0;
        restart();
      } else {
        display = 1;
        restart();        
      }
    }

void outfile() {
  selectOutput("Select a file to write to:", "savefileSelected");
}
   
void infile() {
   selectInput("Select a file to process:", "loadfileSelected");
}


void loadfileSelected(File selection) {
  if (selection == null) {
    println("Window was closed or the user hit cancel.");
  } else {
    println("User selected " + selection.getAbsolutePath());
    loaded = selection.getAbsolutePath();
    start = 1;
    restart();
  }
}

void savefileSelected(File selection) {
  if (selection == null) {
    println("Window was closed or the user hit cancel.");
  } else {
    println("User selected " + selection.getAbsolutePath());
    saver = selection.getAbsolutePath();
    start = 1;
    restart();
  }
}

void restart(){
    if (start == 1) { //<>//
      println ("starting");
    original_img = loadImage(loaded);
    original_img.resize(600, 600);
    original_img.filter(GRAY);
    maskImage = createGraphics(600,600);
    maskImage.beginDraw();
    maskImage.ellipse(302.5, 302.5, 600, 600);
    maskImage.endDraw();
    original_img.mask(maskImage);
      start =0;
    } else {
      fibdraw.background(255);
  }
    loop();
    frameCount = counter = 0; 
    x = 0; y = 0; z = 34;
      if (reverse == 1){original_img.filter(INVERT); reverse =0; } //<>//
    fibdraw = createGraphics(600, 600, SVG, saver + ".svg"); //.svg save file name
    fibdraw.beginDraw();
    fibdraw.stroke(0);
    fibdraw.strokeWeight(1);
    fibdraw.noFill();
  if (display == 1){
    println("display image");
     image(original_img, 0, 0);}
    else {
      background(254);
    }
    x = width/2; y = height/2;
    loop();
}
